/* $Id$ */
/*============================================================================*
 |                 Copyright (c) 2016 Applaud Solutions UK Ltd                |
 |                             All rights reserved                            |
 *===========================================================================*/

SET VERIFY OFF
SET FEEDBACK OFF
SET SCAN OFF
WHENEVER OSERROR  EXIT FAILURE ROLLBACK
WHENEVER SQLERROR EXIT FAILURE ROLLBACK

DECLARE

  --
  -- Local constants and variables
  --
  l_SERVICE CONSTANT xxas_com_service_repository.service_name%TYPE
                       := 'VacationRules';
                       
BEGIN
      
  xxas_com_sr_pkg.set_rest_service
    (p_service_name       => l_SERVICE
    ,p_description        => 'Interact with workflow vacation rules'
    ,p_path               => 'vacation-rules'
    ,p_consumes           => 'application/xml'
    ,p_produces           => 'application/xml'
    );
    
  xxas_com_sr_pkg.set_rest_method
    (p_service_name       => l_SERVICE
    ,p_method_name        => 'Respond to Vacation Rules'
    ,p_description        => 'Respond to one or more  Rules'
    ,p_path               => '{action}'
    ,p_methods            => 'DELETE'
    ,p_plsql              =>
      q'[
         DECLARE
        
          l_xml         XMLType;
          l_resp        xxas_http_resp_obj;
          l_request_xml XMLType;
          
        BEGIN
        
          l_request_xml := {requestBody};

          xxas_com_worklist_pkg.bulk_respond_vac_rules
            (p_action       => {pathParam.action}
            ,p_request_body => l_request_xml);
              
          l_resp := xxas_http_response
                      .ok(xxas_com_msg_pkg.get_success_message_xml
                           (xxas_com_msg_type(xxas_util_pkg.app, 'XXAS_COM_CHNG_SAVE', null)
						   ,'self'
						   ,'modal'
                           )
                         )
                      .build();
         
         {response} := l_resp;

        END
      ]'
    );
	
	 xxas_com_sr_pkg.set_rest_method
    (p_service_name       => l_SERVICE
    ,p_method_name        => 'Delete action to Vacation Rules'
    ,p_description        => 'Delete action to Vacation Rules'
    ,p_path               => 'DELETE/{ruleId}'
    ,p_methods            => 'DELETE'
    ,p_plsql              =>
      q'[
         DECLARE
          
          l_xml                 XMLType;
          l_resp                xxas_http_resp_obj;
          
        BEGIN
                  
          xxas_com_worklist_pkg.remove_wf_rule
            (p_rule_id              => {pathParam.ruleId}
             ,p_response_xml         => l_xml
            );
          
         l_resp := xxas_http_response
                      .ok(l_xml)
                      .build();
                      
         {response} := l_resp;

        END
      ]'
    );
    
END;
/
COMMIT;
EXIT;
